SystemOrganization addCategory: #'Tests-ObjectsAsMethods'!

Object subclass: #AbstractObjectsAsMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-ObjectsAsMethods'!

!AbstractObjectsAsMethod methodsFor: 'as yet unclassified' stamp: 'md 3/1/2006 14:25'!
flushCache! !

!AbstractObjectsAsMethod methodsFor: 'as yet unclassified' stamp: 'md 3/1/2006 14:23'!
methodClass: aMethodClass! !

!AbstractObjectsAsMethod methodsFor: 'as yet unclassified' stamp: 'md 3/1/2006 14:23'!
selector: aSymbol! !

AbstractObjectsAsMethod subclass: #ObjectsAsMethodsExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-ObjectsAsMethods'!

!ObjectsAsMethodsExample methodsFor: 'as yet unclassified' stamp: 'ar 5/17/2003 20:16'!
add: a with: b
	^a + b! !

!ObjectsAsMethodsExample methodsFor: 'as yet unclassified' stamp: 'ar 5/17/2003 20:16'!
answer42
	^42! !

!ObjectsAsMethodsExample methodsFor: 'as yet unclassified' stamp: 'md 3/1/2006 19:37'!
run: oldSelector with: arguments in: aReceiver
	^self perform: oldSelector withArguments: arguments! !

TestCase subclass: #TestObjectsAsMethods
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-ObjectsAsMethods'!

!TestObjectsAsMethods methodsFor: 'running' stamp: 'al 2/9/2009 20:19'!
setUp
	SystemChangeNotifier uniqueInstance doSilently: [
		self class addSelector: #add:with: withMethod: ObjectsAsMethodsExample new.
		self class addSelector: #answer42 withMethod: ObjectsAsMethodsExample new.
		self class addSelector: #foo withMethod: AbstractObjectsAsMethod new ]! !

!TestObjectsAsMethods methodsFor: 'running' stamp: 'al 2/9/2009 20:19'!
tearDown
	SystemChangeNotifier uniqueInstance doSilently: [
		self class removeSelector: #add:with:.
		self class removeSelector: #answer42.
		self class removeSelector: #foo ]! !

!TestObjectsAsMethods methodsFor: 'testing' stamp: 'al 2/9/2009 19:55'!
testAddNumbers
	self assert: (self add: 3 with: 4) = 7.
	self assert: (self perform: #add:with: withArguments: #(3 4)) = 7.! !

!TestObjectsAsMethods methodsFor: 'testing' stamp: 'al 2/9/2009 19:52'!
testAnswer42 
	self assert: self answer42 = 42! !

!TestObjectsAsMethods methodsFor: 'testing' stamp: 'al 2/9/2009 19:52'!
testDNU 
	self should: [self foo] raise: MessageNotUnderstood! !
